<?php
add_filter('plugins_api', 'cw_plugin_info', 20, 3);
function cw_plugin_info( $res, $action, $args ){
	if( $action !== 'plugin_information' )
		return false;
	if( 'clubwpress-updater' !== $args->slug )
		return false;
	if( false == $remote = get_transient( 'cw_upgrade_updater' ) ) {
		$remote = wp_remote_get( 'https://clubwpress.net/cw_updater_plugin/info.json', array(
			'timeout' => 10,
			'headers' => array(
				'Accept' => 'application/json'
			) )
		);
		if ( !is_wp_error( $remote ) && isset( $remote['response']['code'] ) && $remote['response']['code'] == 200 && !empty( $remote['body'] ) ) {
			set_transient( 'cw_upgrade_updater', $remote, 43200 ); // 12 hours cache
		}
	}
	if( $remote ) {
		$remote = json_decode( $remote['body'] );
		$res = new stdClass();
		$res->name = $remote->name;
		$res->slug = $remote->slug;
		$res->version = $remote->version;
		$res->tested = $remote->tested;
		$res->requires = $remote->requires;
		$res->author = $remote->author;
		$res->download_link = $remote->download_url;
		$res->trunk = $remote->download_url;
		$res->last_updated = $remote->last_updated;
		$res->sections = array(
			'changelog' => $remote->sections->changelog
		);
		if( !empty( $remote->sections->screenshots ) ) {
			$res->sections['screenshots'] = $remote->sections->screenshots;
		}
        return $res;
	}
	return false;
}
add_filter('site_transient_update_plugins', 'cw_push_update' );

function cw_push_update( $transient ){
	if ( empty($transient->checked ) ) {
            return $transient;
        }
	if( false == $remote = get_transient( 'cw_upgrade_updater' ) ) {
		$remote = wp_remote_get( 'https://clubwpress.net/cw_updater_plugin/info.json', array(
			'timeout' => 10,
			'headers' => array(
				'Accept' => 'application/json'
			) )
		);

		if ( !is_wp_error( $remote ) && isset( $remote['response']['code'] ) && $remote['response']['code'] == 200 && !empty( $remote['body'] ) ) {
			set_transient( 'cw_upgrade_updater', $remote, 43200 ); // 12 hours cache
		}
	}

	if( !is_wp_error( $remote ) && $remote ) {
		$remote = json_decode( $remote['body'] );
		if( $remote && version_compare( CLUBWORDPRESS_VERSION, $remote->version, '<' )
			&& version_compare($remote->requires, get_bloginfo('version'), '<' ) ) {
            $res = new stdClass();
            $res->slug = $remote->slug;
            $res->plugin = $remote->slug;
            $res->new_version = $remote->version;
            $res->tested = $remote->tested;
            $res->package = $remote->download_url;
            $res->compatibility = new stdClass();
            $transient->response[$res->plugin] = $res;
        }

	}
     return $transient;
}

add_action( 'upgrader_process_complete', 'cw_after_update', 10, 2 );

function cw_after_update( $upgrader_object, $options ) {
	if ( $options['action'] == 'update' && $options['type'] === 'plugin' )  {
		delete_transient( 'cw_upgrade_updater' );
	}
}
