<?php

class CwSlmClient {

	public function __construct() {	
		add_action( 'wp_loaded', array( $this, 'init' ) );		
	}
    
	public static function init() {
		add_shortcode( 'cwlcl', array( __CLASS__, 'cwlclient_func' ) );
		add_action( 'deactive_cwl_key', array( __CLASS__, 'deactive_key' ), 10, 1 );
		$action1 = 'cwl-client-ajax-action';
		add_action( 'wp_ajax_' . $action1, array( __CLASS__, 'cwlclient_charge_callback' ) );
		add_action( 'wp_ajax_nopriv_' . $action1, array( __CLASS__, 'cwlclient_charge_callback' ) );
		$action2 = 'cwl-client-ajax-deactivate-action';
		add_action( 'wp_ajax_' . $action2, array( __CLASS__, 'cwlclient_deactivate_callback' ) );
		add_action( 'wp_ajax_nopriv_' . $action2, array( __CLASS__, 'cwlclient_deactivate_callback' ) ); 
        $action3 = 'cwl-client-ajax-get-products';
		add_action( 'wp_ajax_' . $action3, array( __CLASS__, 'cwlclient_get_products_callback' ) );
		add_action( 'wp_ajax_nopriv_' . $action3, array( __CLASS__, 'cwlclient_get_products_callback' ) );
		$action4 = 'cwl-client-ajax-install-product';
		add_action( 'wp_ajax_' . $action4, array( __CLASS__, 'cwlclient_install_product_callback' ) );
		add_action( 'wp_ajax_nopriv_' . $action4, array( __CLASS__, 'cwlclient_install_product_callback' ) );    
	}

	public static function cwlclient_func( $atts, $content = null ) {
		$a = shortcode_atts(
			array(
				'item_reference'     => '',
				'sales_site_url'     => '',
				'license_server_url' => '',
				'special_secretkey'  => '',
			),
			$atts
		);

		if ( get_option( 'cwlclient' ) ) {
			$settings_tbl = get_option( 'cwlclient' );
			foreach ( $settings_tbl as $key => $value ) {
				$shortcodekey = strtolower( $key );
				if ( empty( $a[ $shortcodekey ] ) ) {
					$a[ $shortcodekey ] = $value;
				}
			}
		} else {
			if ( empty( $a['item_reference'] ) ||
				 empty( $a['sales_site_url'] ) ||
				 empty( $a['license_server_url'] ) ||
				 empty( $a['special_secretkey'] ) ) {
				return;
			}
		}

		$a2                     = self::atts_item( $a );
		$license_key_name       = $a2['license_key_name'];
		$sales_site_url         = $a2['sales_site_url'];
		$a2['cwl_text_message'] = __( 'Site activated successfully !', 'clubwpress-updater' );
		$a2['cwl_expired_message'] = __( 'Your License key has expired. You\'re pleased to buy a new one on <a href="https://clubwpress.net/en">ClubWordPress.net</a>', 'clubwpress-updater' );
		$a2['cwl_invalid_message'] = __( 'Your email or license is invalid. You\'re pleased to double check one on <a href="https://clubwpress.net/en">ClubWordPress.net</a>', 'clubwpress-updater' );
		$a2['cwl_max_domains_message'] = __( 'You have reached the maximum allowed domains for this licence. You\'re pleased to buy a new one on <a href="https://clubwpress.net/en">ClubWordPress.net</a>', 'clubwpress-updater' );
	    $a2['cwl_deactivation_text_message'] = __( 'The license key has been deactivated for this domain.', 'clubwpress-updater' );
        
		$handle  = 'cwl-client-ajax-script';
        if ( ! get_option( $license_key_name ) ) {
            $action = 'cwl-client-ajax-action';
        }else{
            $action = 'cwl-client-ajax-deactivate-action';
        }
		wp_enqueue_script( $handle, plugin_dir_url( __DIR__ ) . 'js/jquery.cwlclient-dist.js' , array( 'jquery' ), '1.0.0', false );
        $lang =  substr(get_locale(),0,2);
        if($lang == 'fr'){
            $subscription_url = 'https://clubwpress.net/abonnements/';
            $free_subscription_url = 'https://clubwpress.net/essai-gratuit/';
        }else{
            $subscription_url = 'https://clubwpress.net/en/subscription-plans/';
            $free_subscription_url = 'https://clubwpress.net/en/free-trial/';
        }  
		$ajax_arr = array(
			'ajax_url' => admin_url( 'admin-ajax.php' ),
			'action'   => $action,
			'nonce'    => wp_create_nonce( $action ),
			'productsNonce'    => wp_create_nonce( 'cwl-client-ajax-get-products' ),
			'installNonce'    => wp_create_nonce( 'cwl-client-ajax-install-product' ),
			'Installed'    => __('Installed', 'clubwpress-updater' ),
			'Install'    => __('Install', 'clubwpress-updater' ),
			'Activate'    => __('Activate', 'clubwpress-updater' ),
			'Activated'    => __('Activated', 'clubwpress-updater' ),
			'Deactivate'    => __('Deactivate', 'clubwpress-updater' ),
			'Deactivated'    => __('Deactivated', 'clubwpress-updater' ),
			'Update'    => __('Update', 'clubwpress-updater' ),
			'Updated'    => __('Updated', 'clubwpress-updater' ),
			'Demo'    => __('Demo', 'clubwpress-updater' ),
			'MoreDetails'    => __('Details', 'clubwpress-updater' ),
			'Updating'    => __('Updating', 'clubwpress-updater' ),
			'LastVersionInstalled'    => __('Lastest version installed', 'clubwpress-updater' ),
			'Installing'    => __('Installing', 'clubwpress-updater' ),
			'Activating'    => __('Activating', 'clubwpress-updater' ),
			'InstallFailed'    => __('Installation Failed', 'clubwpress-updater' ),
			'ActivationFailed'    => __('Activation Failed', 'clubwpress-updater' ),
			'DownloadLimitExceeded'    => __('Download Limit Exceeded', 'clubwpress-updater' ),
			'GotThat'    => __('Got That !', 'clubwpress-updater' ),
			'NoLicence'    => __('No Licence', 'clubwpress-updater' ),
			'TryManualInstallation'    => __('An error occured, sorry for that. Check in your extensions or themes if the product has been installed. Or try a manual installation for this product. Be sure that we\'re working on it.', 'clubwpress-updater' ),
            'RestoreVersion'    => __('Restore to version', 'clubwpress-updater' ),
            'RestoringtoVersion'    => __('Restoring to version', 'clubwpress-updater' ),
            'Restored'    => __('Restored', 'clubwpress-updater' ),
            'RestorationFailed'    => __('Restoration Failed', 'clubwpress-updater' ),
            'NoAccess'    => __('Ohh! It appears that you don\'t have access to product downloads. Click the link below to get a subscription to the Club.', 'clubwpress-updater' ),
            'NoFreeAccess'    => __('This item is free of charge but you need to open an account and enter your free license key in order to install it.', 'clubwpress-updater' ),
            'GetAFreeLicence'    =>  __('Get a Free Licence', 'clubwpress-updater' ),
            'subscription_url'    => $subscription_url,
            'free_subscription_url'    => $free_subscription_url,
            'SeeSubscriptionsPlans'    => __('See Subscriptions Plans', 'clubwpress-updater' ),
            'NoThx'    => __('No Thanks', 'clubwpress-updater' ),
            
		);
		$ajax_arr = array_merge( $ajax_arr, $a2 );
		wp_localize_script( $handle, 'CWLCLIENTCHARGE', $ajax_arr );
		$readonly = null;

        $xclass = '';
        if ( ! get_option( $license_key_name ) ) {
            $xclass = 'open';
        }
		$content  = '<div class="wrap cw_box cw_licence_box '.$xclass.'">';
		if ( ! get_option( $license_key_name ) ) {
			$content .= '<div class="cwl_text_message error">';
			$content .= '<p>'.__( 'Please enter the license key for this product to activate it. You can find your license key in your account area on <a href="https://clubwpress.net/en">ClubWordPress.net</a>.', 'clubwpress-updater' );
			$content .= '</p>';
		} else {
			$content .= '<div class="cwl_text_message updated">';
			$content .= '<p>'.__( 'Domain activated.', 'clubwpress-updater' ).'</p>';
		}
		$content .= '</div><div class="cw_licence_box_content">';
        
        $content .= '<span class="toggle '.$xclass.'"></span><h3><strong>' . __( 'Activate your domain', 'clubwpress-updater' ) . '</strong></h3>';

        $content .= '<div class="form-group"><label for="' . $license_key_name . '">' . __( 'License Key', 'clubwpress-updater' ) . '</label>';
		
		if ( get_option( $license_key_name ) ) {
			$readonly = ' readonly="readonly"';
		}
		$content .= '<input class="regular-text" type="password" id="' . $license_key_name . '" name="' . $license_key_name . '" value="' . get_option( $license_key_name ) . '"' . $readonly . ' >';
        
        $content .= '</div>';
        
		$content .= '<div class="form-group"><label for="email">' . __( 'Email', 'clubwpress-updater' ) . '</label>';
		if ( get_option( $license_key_name ) ) {
			$readonly = ' readonly="readonly"';
		}
		$content .= '<input class="regular-text" type="email" id="email" name="email" value="' . get_option( 'cw_updater_email' ) . '"' . $readonly . ' >';
		
		$content .= '</div>';
		
		
        
        
		if ( get_option( $license_key_name ) ) {
			$content .= '<div class="form-group">';

			$content .= '<button type="button" class="button-primary" id="deactivate_license">' . __( 'Deactivate this domain', 'clubwpress-updater' ) . '</button>';
			$content .= '</div>';

		} else {
			$content .= '<div class="form-group">';


			$content .= '<button type="button" class="button-primary" id="activate_license">' . __( 'Activate', 'clubwpress-updater' ) . '</button>';

			$content .= '</div>';
		}
		$content .= '</div></div>';

		return do_shortcode( $content );
	}

	private static function atts_item( $atts ) {
		$new_atts = array();
		$text                       = $atts['item_reference'];
		$text                       = trim( mb_convert_kana( $text, 'as', 'UTF-8' ) );
		$text                       = preg_replace( '/[^0-9a-z_-]/', '', $text );
		$new_atts['item_reference'] = substr( $text, 0, 20 );
		$new_atts['license_key_name'] = 'license_key_' . $new_atts['item_reference'];
		$new_atts['sales_site_url'] = "'" . $atts['sales_site_url'] . "'";
		$new_atts['license_server_url'] = $atts['license_server_url'];
		$new_atts['special_secretkey'] = $atts['special_secretkey'];
		return $new_atts;
	}

	private static function cwl_verifi( $atts, $license_key, $cwl_action ) {
		global $my_query;
		$item_reference     = $atts['item_reference'];
		$license_server_url = $atts['license_server_url'];
		$special_secretkey  = $atts['special_secretkey'];
		if(isset($atts['email'])){
			$email = $atts['email'];
		}else{
			$email = "";
		}
        $lang =  substr(get_locale(),0,2);   
        if($lang == "fr"){
			$lang = "fr";
		}else{
			$lang = "en";
		}
        
		$domain_name = esc_url( home_url() );
		if ( is_ssl() ) {
			$domain_name = str_replace( 'https://', '', $domain_name );
		} else {
			$domain_name = str_replace( 'http://', '', $domain_name );
		}

		$api_params = array(
			'cwl_action'        => $cwl_action,
			'secret_key'        => $special_secretkey,
			'license_key'       => $license_key,
			'email'       =>   $email,
			'lang'       =>   $lang,
			'domain' => $domain_name,
			'item_reference'    => urlencode( $item_reference ),
		);
        if(isset($atts['cwl_product'])){
			$api_params['cwl_product']   = $atts['cwl_product'];
		}
		$query  = esc_url_raw( add_query_arg( $api_params, $license_server_url ) );
        
        
		$my_query = $query."&rand=".rand();
        
		$response = wp_remote_get(
			$my_query,
			array(
				'timeout' => 100,
				'sslverify' => false,
			)
		);
        
       
      
		if ( is_wp_error( $response ) ) {
			echo '  '.__('Please reload the page', 'clubwpress-updater');
		}
  
        
		$license_data = json_decode( wp_remote_retrieve_body( $response ) );

     

		return $license_data;
	}

	public static function cwlclient_charge_callback( $license_key = null ) {

		$action1 = 'cwl-client-ajax-action';
		if ( check_ajax_referer( $action1, 'nonce', false ) ) {
			if ( isset( $_POST['license_key'] ) && ! empty( $_POST['license_key'] ) ) {
				$license_key = sanitize_text_field( wp_unslash( $_POST['license_key'] ) );
			}
			if ( isset( $_POST['license_key_name'] ) && ! empty( $_POST['license_key_name'] ) ) {
				$atts['license_key_name'] = sanitize_text_field( wp_unslash( $_POST['license_key_name'] ) );
			}
			if ( isset( $_POST['special_secretkey'] ) && ! empty( $_POST['special_secretkey'] ) ) {
				$atts['special_secretkey'] = sanitize_text_field( wp_unslash( $_POST['special_secretkey'] ) );
			}
			if ( isset( $_POST['item_reference'] ) && ! empty( $_POST['item_reference'] ) ) {
				$atts['item_reference'] = sanitize_text_field( wp_unslash( $_POST['item_reference'] ) );
			}
			if ( isset( $_POST['license_server_url'] ) && ! empty( $_POST['license_server_url'] ) ) {
				$atts['license_server_url'] = esc_url_raw( wp_unslash( $_POST['license_server_url'] ) );
			}
		    if ( isset( $_POST['email'] ) && ! empty( $_POST['email'] ) ) {
				$atts['email'] = sanitize_text_field( wp_unslash( $_POST['email'] ) );
			}
			$license_data = self::cwl_verifi( $atts, $license_key, 'cwl_activate' );
			if ( 'success' == $license_data->result || ('error' == $license_data->result &&  $license_data->error_code == 40)) {
				update_option( $atts['license_key_name'], $license_key );

				if(isset($atts['email']) && $atts['email'] != ''){
					update_option( 'cw_updater_email', $atts['email'] );
				}	
				if ( ! is_null( $license_key ) ) {
					$license_key = apply_filters( 'cwlclient_licensed', $license_key, $atts['item_reference'] );
					if ( is_wp_error( $license_key ) ) {
						echo $license_key;
					}
				}
			}
			echo json_encode($license_data);
			die();
		} else {
			status_header( '403' );
			echo 'Forbidden';
		}
	}

	public static function cwlclient_deactivate_callback( $license_key = null ) {

        if ( isset( $_POST['license_key'] ) && ! empty( $_POST['license_key'] ) ) {
            $license_key = sanitize_text_field( wp_unslash( $_POST['license_key'] ) );
        }
        if ( isset( $_POST['license_key_name'] ) && ! empty( $_POST['license_key_name'] ) ) {
            $atts['license_key_name'] = sanitize_text_field( wp_unslash( $_POST['license_key_name'] ) );
        }
        if ( isset( $_POST['email'] ) && ! empty( $_POST['email'] ) ) {
            $atts['email'] = esc_url_raw( wp_unslash( $_POST['email'] ) );
        }
		$action2 = 'cwl-client-ajax-deactivate-action';
		if ( check_ajax_referer( $action2, 'nonce', false ) ) {

			$args = array( 'item_reference' => 'clubwordpress', 'sales_site_url' => 'https://clubwpress.net/', 'license_server_url' => 'https://clubwordpress.net/', 'special_secretkey' => '5d821b02b62ab1.82233812', 'is_ajax' => '1' );

			$arg = array_merge( $args, $atts );

			$license_data = 
			self::deactive_key( $arg );
			if($license_data){
				echo json_encode($license_data);
			}else{
				echo 'empty';
			}	
			die();
		} else {
			status_header( '403' );
			echo 'Forbidden';
		}
	}
    
	public static function deactive_key( $arg ) {
		$arg2              = self::atts_item( $arg );
		$license_key_name  = $arg2['license_key_name'];
		$license_key       = get_option( $license_key_name );
		$license_data      = self::cwl_verifi( $arg2, $license_key, 'cwl_deactivate' );

		if ( is_object( $license_data ) ) {
			if ( property_exists( $license_data, 'result' ) ) {
				if ( 'success' == $license_data->result || ('error' == $license_data->result && $license_data->error_code == 80) ) {
					delete_option( $license_key_name );
					delete_option('cw_updater_email' );
					delete_option('cw_db_version' );
				}
			}
		}
		
		return $license_data;
	}

	public static function get_time_difference( $start, $end )
	{	
		$uts['start']      =     $start ;
		$uts['end']        =      $end ;	
		if( $uts['start']!==-1 && $uts['end']!==-1 )
		{
			if( $uts['end'] >= $uts['start'] )
			{
				$diff    =    $uts['end'] - $uts['start'];	
				return round($diff,0);	
			}	
		}
	}

	public static function get_updates() {
		global $my_query;
        $force = false;
 		$last_json_update = get_option('cw_last_json_update');
 		$difference = '';
 		if($last_json_update){
 			$difference = self::get_time_difference($last_json_update, time());
 		}
        if(isset($_POST['force_update']) && $_POST['force_update'] == 'cW0rluBPr355'){
            $force = true;
        }
        
        $timezone  = 0;
        $jour = gmdate("j", time()); 
        $last_dc_update_jour = get_option('cw_last_dc_update');
        if(!isset($last_dc_update_jour) || $last_dc_update_jour != $jour){
            update_option('cw_remaining_downloads_today', 25);
            update_option('cw_last_dc_update', $jour);
        }
        if((!$last_json_update || $difference > 12 * 3600 || $force)){
            $args = array( 'item_reference' => 'clubwordpress', 'sales_site_url' => 'https://clubwpress.net/', 'license_server_url' => 'https://clubwordpress.net/', 'special_secretkey' => '5d821b02b62ab1.82233812');
            $arg2  = self::atts_item( $args );
            $arg2['email'] =  get_option( 'cw_updater_email' );
            $lang =  substr(get_locale(),0,2);    
            $license_key_name  = $arg2['license_key_name'];
            $license_key       = get_option( $license_key_name );
            $data      = self::cwl_verifi( $arg2, $license_key, 'cwl_get_updates' );
            $json_articles = null;
        
            if ( is_object( $data ) ) {
                if ( property_exists( $data, 'result' ) ) {
                    $articles = $data->articles;
                    if($articles){
                        $request = wp_remote_get($articles, array('timeout' => 120));
                     
                        $zip = $request['body'];
                       
                        if($lang == 'fr'){
                              $updates_file = 'cw_updates.txt';
                             $zip_updates_file = 'cw_updates.zip';
                         }else{
                             $updates_file = 'cw_updates_en.txt';
                             $zip_updates_file = 'cw_updates_en.zip';
                         }  
                        $zipfilepath =  str_replace('clubwp-client.php', $zip_updates_file, __FILE__);
                           
                        
                        $fp = fopen($zipfilepath, "w");
                        fwrite($fp, $zip);
                        fclose($fp);
                        WP_Filesystem();
                        $dir = plugin_dir_path( __FILE__ );
                        
                        if (unzip_file($zipfilepath, $dir)) {
                            if(file_exists($dir.$updates_file)){
                                $updates_file_content = file_get_contents($dir.$updates_file);
                                $json_articles = json_decode($updates_file_content);  
                            }
                        }
                      
                      

                        if( !is_wp_error($request) || wp_remote_retrieve_response_code($request) === 200) {     
                                
                            if($json_articles !== null ) {
                                $cw_table = CLUBWORDPRESS_TBL_KEY;
                                global $wpdb;
                                $wpdb->query( 'TRUNCATE TABLE '.$cw_table  );
                                $fields = array();
                                $setting_values = array();

                                foreach ($json_articles as $key => $value) {
                                    $fields = array(
                                        'item_name' =>  "'" .$value->item_name. "'",
                                        'type' =>  "'" .$value->type. "'",
                                        'version' =>  "'" .$value->version. "'",
                                        'filepath' =>  "'" .$value->filepath. "'",
                                        'image' =>  "'" .$value->image. "'",
                                        'excerpt' =>  "'" .$value->excerpt. "'",
                                        'permalink' =>  "'" .$value->permalink. "'",
                                        'demo' =>  "'" .$value->demo. "'",
                                        'update_date' =>  "'" .$value->update_date. "'",
                                        'ordering' =>  "'" .$value->ordering. "'",
                                        'product_id' =>  "'" .$value->product_id. "'",
                                        'is_free' =>  "'" .$value->is_free. "'",
                                    );
                                    $setting_values[] = "(" . implode(',', $fields) . ")";
                                }

                                $chunks = array_chunk($setting_values, 1000);
                                $setting_save_error = 0;
                                foreach($chunks as $chunk){
                                    
                                    $settingSubmit = implode(',', $chunk);

                                    $setting_sql  = "INSERT INTO " . $cw_table . "
                                            (item_name, type, version, filepath, image, excerpt, permalink, demo, update_date, ordering, product_id, is_free)
                                            VALUES " . $settingSubmit;

                                    $setting_save = $wpdb->query( $setting_sql);
                                    if(!$setting_save){
                                        $setting_save_error++;
                                    }
                                    sleep(1);
                                }


                                if($setting_save_error == 0){
                                    update_option('cw_last_json_update', time());
                                }
                            }
                        }
                    }

                    if ( 'success' == $data->result ) {

                    }elseif( 'error' == $data->result  && ($data->error_code == 60 || $data->error_code == 90)){
                        return false;
                    }
                }
            }
		}
	}
    
    public static function cwlclient_get_products_callback( ) {
		$action3 = 'cwl-client-ajax-get-products';
        $output = '';
		if ( check_ajax_referer( $action3, 'nonce', false ) ) {
            global $wpdb;
            $cwpm = new CW_Plugin_Activation();
            $cw_table = CLUBWORDPRESS_TBL_KEY;
            $query = "SELECT * FROM " . $cw_table . " ";
            $queryNum = "SELECT COUNT(*) FROM " . $cw_table . " ";
             $nextstart = ' WHERE ';
            if(isset($_POST['s']) && $_POST['s']!= '' ){
                $s = esc_sql($_POST['s']);
                $query .= $nextstart." (item_name LIKE '%$s%' OR excerpt LIKE '%$s%' OR filepath LIKE '%$s%') ";
                $queryNum .= $nextstart." (item_name LIKE '%$s%' OR excerpt LIKE '%$s%' OR filepath LIKE '%$s%') ";
                $nextstart = ' AND ';
            }
            $type = '';
            if(isset($_POST['filter']) && $_POST['filter']!= ''  && $_POST['filter']!= 'installed'  && $_POST['filter']!= 'free' ){
                 if(stristr($_POST['filter'], 'plugin')){
                    $type = 'plugin';
                }else{
                    $type = 'theme';
                }
                $query .= $nextstart." type = '$type' ";
                $queryNum .= $nextstart." type = '$type' ";
            }
            
             if(isset($_POST['filter']) && $_POST['filter'] != ''  && $_POST['filter'] == 'free' ){
                
                $query .= $nextstart." is_free = 1 ";
                $queryNum .= $nextstart." is_free = 1 ";
            }
            
            
            if(isset($_POST['filter']) && $_POST['filter'] != '' && $_POST['filter'] == 'installed' ){
                $installed_plugins = array_keys($cwpm->get_plugins());
                $installed_wp_themes = wp_get_themes();
                $installed_themes = array();
                foreach($installed_wp_themes as $theme_slug => $theme_infos){
                    $installed_themes[] = $theme_slug.'/style.css';
                }
                $installed_products = array_merge($installed_themes, $installed_plugins);
                $query .= $nextstart." filepath IN ('".implode("','", $installed_products)."')";
                $queryNum .= $nextstart." filepath IN ('".implode("','", $installed_products)."')";
            }
            $items_per_page = 20;
            $page = isset( $_POST['cpage'] ) ? abs( (int) $_POST['cpage'] ) : 1;
            $offset = ( $page * $items_per_page ) - $items_per_page;
            $order = ( (isset($_POST['order']) && $_POST['order'] != '') ? $_POST['order'] : 'update_date');
            $query =  $query . "GROUP BY product_id  ORDER BY ${order} DESC  LIMIT ${offset}, ${items_per_page}";
            $results = $wpdb->get_results( $query );
           
            $num = $wpdb->get_var($queryNum);
            $res = array();
            $res['query'] = $query;
            $res['num_rows'] = $num;
            $new_results = array();
            foreach($results as $result){
                $filepath = $result->filepath;
                $type = $result->type;
                $version = $result->version;
                $slug = $filepath;
                $short_slug = explode('/', $filepath);
                $short_slug = $short_slug[0];
                $cw_backups = get_option('cw_backups');
                if(($result->type == 'plugin' && $cwpm->is_plugin_installed($filepath)) || ($result->type == 'theme' && $cwpm->is_theme_installed($short_slug))){
                    $result->is_installed = 1;
                        if (( $result->type == 'plugin' && is_plugin_active( $slug )) || ($result->type == 'theme' && $cwpm->is_theme_active($short_slug))){
                        $result->is_plugin_active = 1;
                    }else{
                        $result->is_plugin_active = 0;
                    }
                    if ($result->type == 'theme'){
                        $result->installed_version = $cwpm->get_installed_theme_version($short_slug);
                    }else{
                        $result->installed_version = $cwpm->get_installed_version($slug);
                    }
                    $result->backed_up_versions = false;
                    $backed_up_versions = self::get_backed_up_versions($result->type, $short_slug, $result->installed_version);
                    if(count($backed_up_versions) > 0){
                        $result->backed_up_versions = $backed_up_versions;
                    }
                    if(version_compare( $version, $result->installed_version) > 0){
                        $result->need_update = 1;
                    }else{
                        $result->need_update = 0;
                    }
                }else{
                    $result->is_installed = 0;
                }
                $new_results[] = $result;
            }
            $res['results'] = $new_results;
            if($res){
             echo $output = json_encode($res);
            }
           die(); 
        }
    }
    
    public static function get_backed_up_versions($type, $short_slug, $installed_version){
        $versions = array();
        $cw_backups = get_option('cw_backups');
        if(is_array($cw_backups)){
             foreach($cw_backups as $filename) {
                $filename = str_replace('.zip','',$filename);
                $filename_parts = explode('_', $filename);
                $version = end($filename_parts);
                if(stristr($filename, $type.'_'.$short_slug) && $installed_version != $version){
                    $versions[] = $version;
                }  
            }  
        }
        return $versions;
    }
    
     public static function update_cw_backups_option(){
        
        $upload = wp_upload_dir();
        $upload_dir = $upload['basedir'];
        $upload_dir = $upload_dir . '/cw_backups/';
        $cw_backups = get_option('cw_backups');
        $new_cw_backups = array();
        foreach(scandir($upload_dir) as $filename) {
            $ext = pathinfo($upload_dir.$filename, PATHINFO_EXTENSION);
            if(!is_file($upload_dir.$filename) || $ext != 'zip'){
                continue;
            }
            $new_cw_backups[] = $filename; 
        }
        update_option('cw_backups', $new_cw_backups);
        return $new_cw_backups;
    }
    
    public static function cwlclient_install_product_callback( ) {

		$action4 = 'cwl-client-ajax-install-product';
        $output = '';
		if ( check_ajax_referer( $action4, 'nonce', false ) ) {
            if ( ! get_option( 'license_key_clubwordpress' )) {
                $res['has_access'] = false;
                $res['reponse'] = 1;
            }
            if(isset($_POST['product_id']) && $_POST['product_id']!= '' ){
                $product_id = $_POST['product_id'];
                $cwpm = new CW_Plugin_Activation();
                if(isset($_POST['cw_action']) && $_POST['cw_action']== 'restore' ){
                     if(isset($_POST['version']) && $_POST['version'] != '' ){
                         $version = $_POST['version'];
                         global $wpdb;
                         $cw_table = CLUBWORDPRESS_TBL_KEY;
                         $query = "SELECT item_name, filepath, type  FROM " . $cw_table . " WHERE product_id = %s";
                         $query = $wpdb->prepare( $query, $product_id );
                         $results = $wpdb->get_row( $query );
                         if($results){
                             $slug = explode('/', $results->filepath);
                             $slug = $slug[0];
                             $_GET['type'] = $results->type;
                             $_GET['item_name']  = $results->item_name;
                             $_GET['plugin']  = $slug;
                             $upload = wp_upload_dir();
                             $upload_dir = $upload['basedir'];
                             $upload_dir = $upload_dir . '/cw_backups/';
                             $zipname = $results->type.'_'.$slug.'_'.$version.'.zip';
                             $source = $upload_dir.$zipname;
                             $_GET['source']  = $source;
                             $_GET['cwpm-restore'] = 'restore-plugin';
                             $_GET['filepath'] = $results->filepath;
                             $_GET['cwpm-nonce'] = wp_create_nonce( 'cwpm-restore' );
                             ob_start();
                             $reponse = $cwpm->do_plugin_install();
                             $reponse_details = ob_get_clean();
                            $res['install_details'] = $reponse_details;
                             if($results->type == 'plugin'){
                                 $installed_version = $cwpm->get_installed_version($results->filepath); 
                             }else{
                                 $installed_version = $cwpm->get_installed_theme_version($slug); 
                             }
                            if($installed_version == $version){
                                $res['restoration_status'] = 'success';
                            }else{
                                $res['restoration_status'] = 'failed';
                            }
                         }
                    }
                   if($res){
                     echo $output = json_encode($res);
                    }
                     die(); 
                }elseif(isset($_POST['cw_action']) && $_POST['cw_action']== 'activate' ){
                     global $wpdb;
                     $cw_table = CLUBWORDPRESS_TBL_KEY;
                     $query = "SELECT item_name, filepath, type  FROM " . $cw_table . " WHERE product_id = %s";
                     $query = $wpdb->prepare( $query, $product_id );
                     $results = $wpdb->get_row( $query );
                     if($results){
                         $res['filepath'] = $results->filepath;
                         $item_name = $results->item_name;
                          if(isset($res['filepath']) && stristr($res['filepath'], '/')){
                            $slug = explode('/', $res['filepath']);
                            $slug = $slug[0];
                            $res['type'] = $results->type;
                            $_GET['type'] = $results->type;
                            if(($results->type == 'plugin' && $cwpm->is_plugin_installed($res['filepath']))|| ($results->type == 'theme' && $cwpm->is_theme_installed($slug))){
                                 $_GET['item_name']  = $item_name;
                                 $_GET['plugin']  = $slug;
                                 $_GET['cwpm-activate'] = 'activate-plugin';
                                 $_GET['filepath'] = $res['filepath'];
                                 $_GET['cwpm-nonce'] = wp_create_nonce( 'cwpm-activate' );
                                 ob_start();
                                 $reponse = $cwpm->do_plugin_install();
                                 $reponse_details = ob_get_clean();
                                if(($results->type == 'plugin' && $cwpm->is_plugin_active($res['filepath'])) || ($results->type == 'theme' && $cwpm->is_theme_active($slug))){
                                     $res['activation_status'] = 'success';
                                     
                                 }else{
                                     $res['activation_status'] = 'failed';
                                 }
                             }
                         }
                     }
                    
                      if($res){
                         echo $output = json_encode($res);
                        }

                     die(); 
                }elseif(isset($_POST['cw_action']) && ($_POST['cw_action'] == 'install' || $_POST['cw_action']== 'update' )){
                
                    $args = array( 'item_reference' => 'clubwordpress', 'sales_site_url' => 'https://clubwpress.net/', 'license_server_url' => 'https://clubwordpress.net/', 'special_secretkey' => '5d821b02b62ab1.82233812');
                    $arg2  = self::atts_item( $args );
                    $arg2['email'] =  get_option( 'cw_updater_email' );
                    $arg2['lang'] =  substr(get_locale(),0,2);
                    $arg2['cwl_product'] =  $product_id;
                    $license_key_name  = $arg2['license_key_name'];
                    $license_key       = get_option( $license_key_name );
                    $data      = self::cwl_verifi( $arg2, $license_key, 'cwl_product_s3_url' );
                  
                    $res = array();
                    if ( is_object( $data ) ) {
                         
                        if ( property_exists( $data, 'result' ) ) {
                            
                        if ( 'success' == $data->result ) {
                             if ( property_exists( $data, 'file_version' ) ) {
                                 $remote_file_version = $data->file_version; 
                             }
                             if ( property_exists( $data, 's3_link' ) ) {
                               $res['s3_link'] = $data->s3_link;
                               $res['remaining_downloads'] = $data->remaining_downloads;
                                
                                 update_option('cw_remaining_downloads_today', $res['remaining_downloads']);
                                
                                 if($res['remaining_downloads'] > 0){
                                     global $wpdb;
                                     $cw_table = CLUBWORDPRESS_TBL_KEY;
                                     $query = "SELECT item_name, filepath, type, version  FROM " . $cw_table . " WHERE product_id = %s";
                                     $query = $wpdb->prepare( $query, $product_id );
                                     $results = $wpdb->get_row( $query );
                                     if($results){
                                         $res['filepath'] = $results->filepath;
                                         $res['item_name'] = $results->item_name;
                                         $res['version'] = $results->version;
                                         if(isset($res['filepath']) && stristr($res['filepath'], '/')){
                                             $slug = explode('/', $res['filepath']);
                                              $slug = $slug[0];
                                               $res['type'] = $results->type;
                                               $_GET['type'] = $results->type;
                                             if($_POST['cw_action']== 'install'){
                                                 if(!$cwpm->is_plugin_installed($res['filepath'])){
                                                     $_GET['item_name']  = $res['item_name'];
                                                     $_GET['plugin']  = $slug;
                                                     $_GET['source']  = $res['s3_link'];
                                                     $_GET['cwpm-install'] = 'install-plugin';
                                                     $_GET['filepath'] = $res['filepath'];
                                                     $_GET['cwpm-nonce'] = wp_create_nonce( 'cwpm-install' );
                                                 ob_start();
                                                 $reponse = $cwpm->do_plugin_install();
                                                 $reponse_details = ob_get_clean();
                                                    if(($results->type == 'plugin' && $cwpm->is_plugin_installed($res['filepath'])) || ($results->type == 'theme' && $cwpm->is_theme_installed($slug))){
                                                         $res['install_status'] = 'success';
                                                         $res['install_details'] = $reponse_details;
                                                     }else{
                                                         $res['install_status'] = 'failed';
                                                         $res['install_details'] = $reponse_details;
                                                     }
                                                 }
                                             }elseif($_POST['cw_action']== 'update'){
                                                if(($results->type == 'plugin' && $cwpm->is_plugin_installed($res['filepath'])) || ($results->type == 'theme' && $cwpm->is_theme_installed($slug))){
                                                    self::backup_previous_version($res['filepath'],$results->type);
                                                     $_GET['item_name']  = $res['item_name'];
                                                     $_GET['version']  = $res['version'];
                                                     $_GET['plugin']  = $slug;
                                                     $_GET['source']  = $res['s3_link'];
                                                     $_GET['cwpm-update'] = 'update-plugin';
                                                     $_GET['filepath'] = $res['filepath'];
                                                     $_GET['cwpm-nonce'] = wp_create_nonce( 'cwpm-update' );
                                                  
                                                     ob_start();
                                                     $reponse = $cwpm->do_plugin_install();
                                                     $reponse_details = ob_get_clean();

                                                        
                                                    if(($results->type == 'plugin' && $cwpm->is_plugin_installed($res['filepath'])  && !$cwpm->does_plugin_require_update($res['filepath'], $remote_file_version)) || ($results->type == 'theme' && $cwpm->is_theme_installed($slug)  && !$cwpm->does_theme_require_update($res['filepath'], $remote_file_version))){
                                                         $res['install_status'] = 'success';
                                                         $res['install_details'] = $reponse_details;
                                                     }else{
                                                         $res['install_status'] = 'failed';
                                                         $res['install_details'] = $reponse_details;
                                                     }
                                                 }
                                             }
                                         }
                                     }
                                 }
                             }elseif(property_exists( $data, 'has_access' ) && $data->s3_link == false){
                                 $res['has_access'] = false;
                                 $res['reponse'] = 3;
                             }
                        }elseif( 'error' == $data->result  && ($data->error_code == 60 || $data->error_code == 90)){
                            $res['has_access'] = false;
                            $res['reponse'] = 4;
                        }
                    }
                    if($res){
                         echo $output = json_encode($res);
                     }
                       die(); 
                    }
                } 
            }
        } 
    }
    
    public static function backup_previous_version($slug, $type){
        $cwpm = new CW_Plugin_Activation();
        $short_slug = explode('/', $slug);
        $short_slug = $short_slug[0];
         if($type == 'plugin'){
             $version = $cwpm->get_installed_version($slug); 
         }else{
             $version = $cwpm->get_installed_theme_version($short_slug); 
         }
        $upload = wp_upload_dir();
        $upload_dir = $upload['basedir'];
        $upload_dir = $upload_dir . '/cw_backups';
        if(is_dir($upload_dir)){
            $cw_backups = get_option('cw_backups');
            $zipname = $type.'_'.$short_slug.'_'.$version.'.zip';
            if($type == 'plugin'){
                $dirPath = WP_PLUGIN_DIR.'/'.$short_slug;
            }else{
               $dirPath = get_theme_root().'/'.$short_slug;
            }
           if(!file_exists($upload_dir.$zipname)){
                if(self::zipPreviousAndMove($dirPath,$zipname)){
                  
                }
           }
            if(!in_array($zipname, $cw_backups)){
                 $cw_backups[] = $zipname;
                 update_option('cw_backups',$cw_backups);
            }
        }
    }

    private static function zipPreviousAndMove($dirPath, $zipname){
         if (!is_dir($dirPath)) {
            throw new InvalidArgumentException("$dirPath must be a directory");
        }
        $zip = new ZipArchive();

        $upload = wp_upload_dir();
        $upload_dir = $upload['basedir'];
        $upload_dir = $upload_dir . '/cw_backups/';
       if(file_exists($upload_dir.$zipname)){
           return $upload_dir.$zipname;
       }
        $zip->open($upload_dir.$zipname, ZipArchive::CREATE | ZipArchive::OVERWRITE);
        $files = new RecursiveIteratorIterator(
            new RecursiveDirectoryIterator($dirPath),
            RecursiveIteratorIterator::LEAVES_ONLY
        );

       $dirPathParts = explode('/', $dirPath);

       if($zip->addEmptyDir(end($dirPathParts))){
        } 

        foreach ($files as $name => $file)
        {
            if (!$file->isDir())
            {
                $filePath = $file->getRealPath();
                $relativePath = end($dirPathParts).'/'.substr($filePath, strlen($dirPath) + 1);
                $zip->addFile($filePath, $relativePath);
            }
        }

        $zip->close();
        return $upload_dir.$zipname;
    }
}

CwSlmClient::init();
add_action( 'clubwordpress_daily_update', array('CwSlmClient', 'get_updates'), 20 );
