<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
class CW_Plugin {
	public function __construct() {
		add_action( 'wp_loaded', array( $this, 'init' ) );
	}
	public static function init() {
		add_action( 'in_admin_header', array( __CLASS__, 'skip_notices' ) , 2 );
		add_action( 'init', array( __CLASS__, 'disable_woothemes_updater_notice' ));
		add_action( 'in_admin_header', array( __CLASS__, 'inactive_notice' ), 3 );
		add_action('admin_print_styles', array( __CLASS__, 'cw_post_admin_styles'));


	}
	public static function skip_notices() {
		echo '<style>.notice-error { display: none; }</style>';	
	
	}
 	public static function inactive_notice() {
		if ( ! get_option( 'license_key_clubwordpress' ) ) { ?>
				<div class="error cw_error">
				<p><?php printf( __( 'Club WordPress Updater has not been activated! %sActivate Now%s to enable automatic updates.', 'clubwpress-updater' ), '<a href="' . esc_url( admin_url( 'admin.php?page=cw_updater_settings' ) ) . '" class="button-primary">', '</a>' ); ?></p>
				</div>
		<?php }
	}
    
	public static function disable_woothemes_updater_notice() {
        add_filter( 'woocommerce_helper_suppress_admin_notices', '__return_true' );
	}


	public static function cw_post_admin_styles() {
		wp_enqueue_style( 'cw-meta',  plugin_dir_url(dirname(__FILE__) ) . 'css/cw-meta.css', false, time(), 'all');
		
	}


}

CW_Plugin::init();